Index: /main/trunk/release-kits/kits/rk2/ant-scripts/compile.xml
===================================================================
--- /main/trunk/release-kits/kits/rk2/ant-scripts/compile.xml	(revision 21724)
+++ /main/trunk/release-kits/kits/rk2/ant-scripts/compile.xml	(revision 21725)
@@ -97,14 +97,4 @@
 		<!-- mac and linux: compile -->
 		<if><bool><or><equals arg1="${rk.os}" arg2="mac"/><equals arg1="${rk.os}" arg2="linux"/></or></bool>
-
-			<!-- WORKAROUND: make common-src and reconfigure -->
-			<!-- this is a workaround to a problem with the gsdl build code -->
-			<!-- expat needs to be compiled before the perl XML Parser is configured -->
-			<exec dir="${basedir}/compiled/common-src" executable="make" failonerror="true"/>
-			<exec dir="${basedir}/compiled" executable="${basedir}/compiled/configure" failonerror="true">
-				<arg line="--enable-apache-httpd"/>
-				<env key="LDFLAGS" value="-static"/>
-			</exec>
-			<!-- /WORKAROUND -->
 
 			<!-- make -->
@@ -236,5 +226,5 @@
 
 			<!-- grab ghostscript binaries -->
-			<delete dir="compiled/bin/darwin/imagemagick"/>
+			<delete dir="compiled/bin/darwin/ghostscript"/>
 			<exec executable="svn">
 				<arg value="export"/>
Index: /main/trunk/release-kits/kits/rk2/ant-scripts/create-cdrom-components.xml
===================================================================
--- /main/trunk/release-kits/kits/rk2/ant-scripts/create-cdrom-components.xml	(revision 21724)
+++ /main/trunk/release-kits/kits/rk2/ant-scripts/create-cdrom-components.xml	(revision 21725)
@@ -121,5 +121,5 @@
 				<fileset dir="${rk.home}/shared/windows/wrapper"/>
 				<fileset dir="${rk.home}/shared/greenstone2/wrapper" includes="*.bmp"/>
-				<fileset dir="${rk.home}/shared/greenstone2/icon" includes="icon.ico"/>
+				<fileset dir="${rk.home}/shared/core/icon" includes="icon.ico"/>
 				<fileset dir="${rk.home}/shared/core/search4j" includes="libsearch4j.cpp,libsearch4j.h"/>
 			</copy>
@@ -154,5 +154,5 @@
 			<!-- create app for cdrom installer -->
 			<copy todir="cdrom/dist/Greenstone-${version}-MacOS.app"><fileset dir="${rk.home}/shared/mac/Wrapper.app"/></copy>
-			<copy todir="cdrom/dist/Greenstone-${version}-MacOS.app/Contents/Resources" file="${rk.home}/shared/greenstone2/icon/icon.icns"/>
+			<copy todir="cdrom/dist/Greenstone-${version}-MacOS.app/Contents/Resources" file="${rk.home}/shared/core/icon/icon.icns"/>
 			<chmod file="cdrom/dist/Greenstone-${version}-MacOS.app/Contents/MacOS/JavaApplicationStub" perm="+x"/>
 
@@ -179,5 +179,5 @@
 			<exec dir="cdrom/dist" executable="bash">
 				<arg value="-c"/>
-				<arg value="tar -czf ../../products/cdrom-components-${version}-linux.tar.gz *"/>
+				<arg value="tar -czf ../../products/cdrom-components-${version}-${rk.os}.tar.gz *"/>
 			</exec>
 		</if></else></if>
Index: /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml
===================================================================
--- /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 21724)
+++ /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 21725)
@@ -84,5 +84,5 @@
 
 			<!-- grab ghostscript binaries -->
-			<delete dir="compiled/gs2build/bin/darwin/imagemagick"/>
+			<delete dir="compiled/gs2build/bin/darwin/ghostscript"/>
 			<exec executable="svn">
 				<arg value="export"/>
Index: /main/trunk/release-kits/shared/core/ant-scripts/wrap.xml
===================================================================
--- /main/trunk/release-kits/shared/core/ant-scripts/wrap.xml	(revision 21724)
+++ /main/trunk/release-kits/shared/core/ant-scripts/wrap.xml	(revision 21725)
@@ -155,11 +155,11 @@
 			<!-- create disk image -->
 			<property name="dmg.name" value="Greenstone-${version}-${os.suffix}"/>
-			<exec dir="products" executable="hdiutil"><arg line="create -ov -size ${dmg.size}k -fs HFS+ -volname ${dmg.name} ${dmg.name}.dmg"/></exec>
+			<exec dir="products" executable="hdiutil" failonerror="true"><arg line="create -ov -size ${dmg.size}k -fs HFS+ -volname ${dmg.name} ${dmg.name}.dmg"/></exec>
 			<!-- mount it -->
-			<exec executable="hdiutil" dir="products"><arg line="attach ${dmg.name}.dmg"/></exec>
+			<exec executable="hdiutil" dir="products" failonerror="true"><arg line="attach ${dmg.name}.dmg"/></exec>
 			<!-- copy file into it -->
 			<exec executable="cp"><arg line="-r wrapped-installer/Greenstone${version}.app /Volumes/${dmg.name}"/></exec>
 			<!-- unmount it-->
-			<exec executable="hdiutil"><arg line="detach /Volumes/${dmg.name}"/></exec>
+			<exec executable="hdiutil" failonerror="true"><arg line="detach /Volumes/${dmg.name}"/></exec>
 		</if></else></if></else></if>
 