Index: /main/trunk/release-kits/kits/rk3/ant-scripts/build.xml
===================================================================
--- /main/trunk/release-kits/kits/rk3/ant-scripts/build.xml	(revision 21747)
+++ /main/trunk/release-kits/kits/rk3/ant-scripts/build.xml	(revision 21748)
@@ -31,3 +31,4 @@
 	<target name="properties" depends="core-properties,gs3-properties"/>
 
+
 </project>
Index: /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml
===================================================================
--- /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 21747)
+++ /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 21748)
@@ -12,8 +12,14 @@
 		</exec>
 
+		<!-- make sure all c++ compilation is done statically on linux -->
+		<if><bool><equals arg1="${rk.os}" arg2="linux"/></bool>
+			<property name="forward.compile.static" value="true"/>
+		</if>
+
 		<!-- run greenstone3's ant prepare -->
 		<ant dir="compiled" inheritAll="false">
 			<target name="prepare"/>
 			<propertyset refid="forward.properties"/>
+			<property name="properties.accepted" value="true"/>
 		</ant>
 
@@ -28,4 +34,5 @@
 			<target name="dist-tidy"/>
 			<propertyset refid="forward.properties"/>
+			<property name="properties.accepted" value="true"/>
 		</ant>
 
Index: /main/trunk/release-kits/kits/sork3/ant-scripts/build.xml
===================================================================
--- /main/trunk/release-kits/kits/sork3/ant-scripts/build.xml	(revision 21747)
+++ /main/trunk/release-kits/kits/sork3/ant-scripts/build.xml	(revision 21748)
@@ -22,4 +22,7 @@
 		<!-- export the greenstone3 base code -->
 		<exec executable="svn"><arg value="export"/><arg value="${svn.root}/main/${branch.path}/greenstone3"/><arg value="distributions/${dist.name}"/></exec>
+		<antcall target="persist-forwarded-properties">
+			<param name="greenstone3basedir" value="distributions/${dist.name}"/>
+		</antcall>
 
 		<!-- set version numbers -->
@@ -30,4 +33,5 @@
 			<property name="properties.accepted" value="true"/>
 			<property name="app.version" value="${version}"/>
+			<propertyset refid="forward.properties"/>
 		</ant>
 
@@ -53,4 +57,6 @@
 			<target name="fix-execute-permissions"/>
 			<target name="fix-execute-permissions-source"/>
+			<propertyset refid="forward.properties"/>
+			<property name="properties.accepted" value="true"/>
 		</ant>
 
@@ -64,5 +70,5 @@
 
 		<!-- create the sourcecode component -->
-		<ant dir="." antfile="${rk.home}/kits/${rk.name}/ant-scripts/create-sourcecode-component.xml" target="create-sourcecode-component"/>
+		<ant dir="${basedir}" antfile="${rk.home}/kits/${rk.name}/ant-scripts/create-sourcecode-component.xml" target="create-sourcecode-component"/>
 	</target>
 
Index: /main/trunk/release-kits/kits/sork3/ant-scripts/create-sourcecode-component.xml
===================================================================
--- /main/trunk/release-kits/kits/sork3/ant-scripts/create-sourcecode-component.xml	(revision 21747)
+++ /main/trunk/release-kits/kits/sork3/ant-scripts/create-sourcecode-component.xml	(revision 21748)
@@ -3,6 +3,6 @@
 <project name="create-sourcecode-component">
 
-	<import file="distributions/${dist.name}/resources/xml/components.xml"/>
-	<import file="distributions/${dist.name}/resources/xml/executables.xml"/>
+	<import file="${basedir}/distributions/${dist.name}/resources/xml/components.xml"/>
+	<import file="${basedir}/distributions/${dist.name}/resources/xml/executables.xml"/>
 
 	<target name="create-sourcecode-component">
Index: /main/trunk/release-kits/shared/greenstone3/ant-scripts/greenstone3-shared.xml
===================================================================
--- /main/trunk/release-kits/shared/greenstone3/ant-scripts/greenstone3-shared.xml	(revision 21747)
+++ /main/trunk/release-kits/shared/greenstone3/ant-scripts/greenstone3-shared.xml	(revision 21748)
@@ -12,13 +12,4 @@
 	<property name="version.major" value="3"/>
 	<target name="gs3-init">
-
-		<!-- don't let greenstone3 block and wait for user input to accept
-			the properties for the build -->
-		<property name="forward.properties.accepted" value="true"/>
-
-		<!-- make sure all c++ compilation is done statically on linux -->
-		<if><bool><equals arg1="${rk.os}" arg2="linux"/></bool>
-			<property name="forward.compile.static" value="true"/>
-		</if>
 
 		<!-- show the property set to be forwarded to greenstone3 -->
@@ -73,16 +64,14 @@
 
 	</target>
+
+	<target name="persist-forwarded-properties">
+		<echoproperties prefix="forward." destfile="${greenstone3basedir}/forward.properties"/>
+		<replaceregexp file="${greenstone3basedir}/forward.properties" match="forward\.(.*)" replace="\1" byline="true"/>
+		<copy file="${greenstone3basedir}/build.properties.in" tofile="${greenstone3basedir}/build.properties"/>
+		<concat destfile="${greenstone3basedir}/build.properties" append="true" fixlastline="yes">
+			<fileset file="${greenstone3basedir}/forward.properties"/>
+		</concat>
+	</target>
 	
-	<!-- unused. this or something similar might need to go back in, to make the forward.properties permanent -->
-	<target name="generate-build-properties">
-		<copy file="${greenstone3.basedir}/build.properties.in" tofile="${greenstone3.basedir}/build.properties"/>
-		<if><bool><istrue value="${install.flax}"/></bool>
-			<rsr file="${greenstone3.basedir}/build.properties" pattern="^#install.flax\s*[=:].*" replacement="install.flax=true"/>
-		</if>
-		<if><bool><isset property="server.default.servlet"/></bool>
-			<rsr file="${greenstone3.basedir}/build.properties" pattern="^#?server.default.servlet\s*[=:].*" replacement="server.default.servlet=${server.default.servlet}"/>
-		</if>
-	</target>
-
 	<!-- create the property set to be forwarded to greenstone3 -->
 	<propertyset id="forward.properties">