Index: /main/trunk/greenstone2/perllib/plugins/ConvertBinaryFile.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ConvertBinaryFile.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/ConvertBinaryFile.pm	(revision 21760)
@@ -498,12 +498,14 @@
     # We use set instead of add here because we only want one value
     $doc_obj->set_utf8_metadata_element($cursection, "FileFormat", $file_type);
-    my $doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/doc.$doc_ext\">";
+    my $srclink_filename = "doc.$doc_ext";
+    #my $doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/doc.$doc_ext\">";
     if ($self->{'keep_original_filename'} == 1) {
-	$doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">";
-    }
-    $doc_obj->add_utf8_metadata ($cursection, "srclink",  $doclink); 
+	$srclink_filename = "[SourceFile]";
+	#$doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">";
+    }
+    #$doc_obj->add_utf8_metadata ($cursection, "srclink",  $doclink); 
     $doc_obj->add_utf8_metadata ($cursection, "srcicon",  "_icon".$doc_ext."_"); 
-    $doc_obj->add_utf8_metadata ($cursection, "/srclink", "</a>"); 
-
+    #$doc_obj->add_utf8_metadata ($cursection, "/srclink", "</a>"); 
+    $doc_obj->add_utf8_metadata ($cursection, "srclink_file", $srclink_filename);
     return 1;
 }
Index: /main/trunk/greenstone2/perllib/plugins/ConvertToRogPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ConvertToRogPlugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/ConvertToRogPlugin.pm	(revision 21760)
@@ -444,8 +444,9 @@
     $doc_obj->associate_file($filename, "doc.$doc_ext", undef, $cursection);
 
-    my $doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/doc.$doc_ext\">";
-    $doc_obj->add_utf8_metadata ($cursection, "srclink",  $doclink); 
+    #my $doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/doc.$doc_ext\">";
+    #$doc_obj->add_utf8_metadata ($cursection, "srclink",  $doclink); 
+    $doc_obj->add_metadata ($section, "srclink_file", "doc.$doc_ext"); 
     $doc_obj->add_utf8_metadata ($cursection, "srcicon",  "_icon".$doc_ext."_"); 
-    $doc_obj->add_utf8_metadata ($cursection, "/srclink", "</a>"); 
+    #$doc_obj->add_utf8_metadata ($cursection, "/srclink", "</a>"); 
     return $ret_val;
 }
Index: /main/trunk/greenstone2/perllib/plugins/ImageConverter.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ImageConverter.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/ImageConverter.pm	(revision 21760)
@@ -244,6 +244,7 @@
 
 
-    $doc_obj->add_metadata ($section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/$assocfilemeta/[Image]\">");
-    $doc_obj->add_metadata ($section, "/srclink", "</a>");
+    #$doc_obj->add_metadata ($section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/$assocfilemeta/[Image]\">");
+    #$doc_obj->add_metadata ($section, "/srclink", "</a>");
+    $doc_obj->add_metadata ($section, "srclink_file", "[Image]"); 
     $doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/$assocfilemeta/[Image]\" width=\"[ImageWidth]\" height=\"[ImageHeight]\">");
 
Index: /main/trunk/greenstone2/perllib/plugins/ImagePlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ImagePlugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/ImagePlugin.pm	(revision 21760)
@@ -131,6 +131,7 @@
 	$doc_obj->associate_file($filename_full_path, $assoc_file, "", $section);
 
-	$doc_obj->add_metadata ($section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
-	$doc_obj->add_metadata ($section, "/srclink", "</a>");
+	#$doc_obj->add_metadata ($section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
+	#$doc_obj->add_metadata ($section, "/srclink", "</a>");
+	$doc_obj->add_metadata ($section, "srclink_file", "[SourceFile]"); 
 	# We don't know the size of the image, but the browser should display it at full size
 	$doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
Index: /main/trunk/greenstone2/perllib/plugins/MP3Plugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/MP3Plugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/MP3Plugin.pm	(revision 21760)
@@ -266,9 +266,9 @@
     $doc_obj->add_metadata ($section, "FileFormat", "MP3");
     
-    $doc_obj->add_metadata ($section, "srclink", 
-			    "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[srcurl]\">");
+    #$doc_obj->add_metadata ($section, "srclink", 
+#			    "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[srcurl]\">");
     $doc_obj->add_metadata ($section, "srcicon", "_iconmp3_");
-    $doc_obj->add_metadata ($section, "/srclink", "</a>");
-
+    #$doc_obj->add_metadata ($section, "/srclink", "</a>");
+    $doc_obj->add_metadata ($section, "srclink_file", "[srcurl]"); 
     my $applet_metadata = $self->{'applet_metadata'};
     if (defined $applet_metadata && $applet_metadata ) {
Index: /main/trunk/greenstone2/perllib/plugins/OggVorbisPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/OggVorbisPlugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/OggVorbisPlugin.pm	(revision 21760)
@@ -137,6 +137,7 @@
 
     $doc_obj->add_metadata ($top_section, "FileFormat", "OggVorbis");
-    $doc_obj->add_metadata ($top_section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
-    $doc_obj->add_metadata ($top_section, "/srclink", "</a>");
+    #$doc_obj->add_metadata ($top_section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
+    #$doc_obj->add_metadata ($top_section, "/srclink", "</a>");
+    $doc_obj->add_metadata ($section, "srclink_file", "[SourceFile]"); 
     $doc_obj->add_metadata ($top_section, "srcicon", "_iconogg_");
 
Index: /main/trunk/greenstone2/perllib/plugins/OpenDocumentPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/OpenDocumentPlugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/OpenDocumentPlugin.pm	(revision 21760)
@@ -262,8 +262,9 @@
 
     #setup to doclink thingi
-    my $doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/$file_only\">";
-    $doc_obj->add_utf8_metadata ("", "srclink",  $doclink); 
+    #my $doclink = "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/$file_only\">";
+    #$doc_obj->add_utf8_metadata ("", "srclink",  $doclink); 
+    $doc_obj->add_metadata ($section, "srclink_file", "[SourceFile]"); 
     $doc_obj->add_utf8_metadata ("", "srcicon",  "<img border=\"0\" align=\"absmiddle\" src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/thumbnail.png\" alt=\"View the Open document\" title=\"View the Open document\">"); 
-    $doc_obj->add_utf8_metadata ("", "/srclink", "</a>"); 
+    #$doc_obj->add_utf8_metadata ("", "/srclink", "</a>"); 
     $self->set_Source_metadata($doc_obj, $file_only);
      $doc_obj->set_utf8_metadata_element("", "FileSize", (-s $filename));
Index: /main/trunk/greenstone2/perllib/plugins/RealMediaPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/RealMediaPlugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/RealMediaPlugin.pm	(revision 21760)
@@ -108,6 +108,7 @@
     $doc_obj->add_metadata($top_section, "FileFormat", "RealMedia");
 
-    $doc_obj->add_metadata($top_section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
-    $doc_obj->add_metadata($top_section, "/srclink", "</a>");
+    #$doc_obj->add_metadata($top_section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
+    #$doc_obj->add_metadata($top_section, "/srclink", "</a>");
+    $doc_obj->add_metadata ($top_section, "srclink_file", "[SourceFile]"); 
     $doc_obj->add_metadata($top_section, "srcicon", "_iconrmvideo_");
 
Index: /main/trunk/greenstone2/perllib/plugins/UnknownPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/UnknownPlugin.pm	(revision 21759)
+++ /main/trunk/greenstone2/perllib/plugins/UnknownPlugin.pm	(revision 21760)
@@ -146,8 +146,9 @@
     $doc_obj->add_utf8_metadata ($section, $assoc_field, $doc_obj->get_source()); # Source metadata is already in utf8 
 
-    $doc_obj->add_metadata ($section, "srclink", 
-			    "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
+    #$doc_obj->add_metadata ($section, "srclink", 
+#			    "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
+    $doc_obj->add_metadata ($section, "srclink_file", "[SourceFile]"); 
     $doc_obj->add_metadata ($section, "srcicon", "_".$self->{'srcicon'}."_");
-    $doc_obj->add_metadata ($section, "/srclink", "</a>");
+    #$doc_obj->add_metadata ($section, "/srclink", "</a>");
     
     # we have no text - add dummy text and NoText metadata