Index: main/trunk/greenstone3/web/WEB-INF/classes/OAIConfig.xml
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/OAIConfig.xml	(revision 21769)
+++ main/trunk/greenstone3/web/WEB-INF/classes/OAIConfig.xml	(revision 21791)
@@ -3,43 +3,43 @@
 -->
 <OAIConfig>       
-	 <!-- The name of this oai repository, which is human readable. -->
-         <repositoryName>Greenstone3 OAI repository</repositoryName>
-	 <!-- The base url to request metadata from this repository.
-            TODO: this element should be determined and overriden dynamically given the osi request url in OAIServer.java. -->
-         <baseURL>http://your-domain-name/greenstone3/oaiserver</baseURL>
-	 <!-- The version of OAI specification this repository supports. -->
-         <protocolVersion>2.0</protocolVersion>
-	 <!-- A UTC date time that is the guaranteed lower limit of all datestamps recording changes, midifications etc. in the repository
-              This element is not necessary in this file since the earliest datestamp is dynamically found out by searching thru all oai collections in the repository to get the earliest built time amongst the collections.
-         <earliestDatestamp>1970-01-01</earliestDatestamp>
-	 -->
-         <!-- The manner in which the repository supports the notion of deleted records -->
-         <deletedRecord>no</deletedRecord>
-	 <!-- The granularity of the datestamp -->
-         <granularity>YYYY-MM-DDThh:mm:ssZ</granularity>
-	 <!-- The repository maintainer email address -->
-         <adminEmail></adminEmail>
-   <!-- Information above this line goes into the response to the Identify request -->
-  <!-- set to no if you don't want a stylesheet to be specified in the OAI output -->
+  <!-- The name of this oai repository, which is human readable. -->
+  <repositoryName>Greenstone3 OAI repository</repositoryName>
+  <!-- The base url to request metadata from this repository.
+  TODO: this element should be determined and overriden dynamically given the osi request url in OAIServer.java. -->
+  <baseURL>http://your-domain-name/greenstone3/oaiserver</baseURL>
+  <!-- The version of OAI specification this repository supports. Can be 2.0 or 1.0 -->
+  <protocolVersion>2.0</protocolVersion>
+  <!-- A UTC date time that is the guaranteed lower limit of all datestamps recording changes, midifications etc. in the repository
+  This element is not necessary in this file since the earliest datestamp is dynamically found out by searching thru all oai collections in the repository to get the earliest built time amongst the collections.
+  <earliestDatestamp>1970-01-01</earliestDatestamp>
+  -->
+  <!-- The manner in which the repository supports the notion of deleted records -->
+  <deletedRecord>no</deletedRecord>
+  <!-- The granularity of the datestamp -->
+  <granularity>YYYY-MM-DDThh:mm:ssZ</granularity>
+  <!-- The repository maintainer email address -->
+  <adminEmail></adminEmail>
+  <!-- Information above this line goes into the response to the Identify request -->
+  <!-- set the following to no if you don't want a stylesheet to be specified in the OAI output -->
   <useOAIStylesheet>yes</useOAIStylesheet>
   <!-- uncomment and set value if you want to use a different stylesheet to the default interfaces/oai/oai2.xsl -->
-   <!--<OAIStylesheet></OAIStylesheet> -->
-         
-	 <!-- The time period in which a newly generated resumption token will remain valid, specified in second. Hence, the default
-              value 7200 is equivalent to 2 hours.        
-              If the resumeAfter parameter is less than 0, this value will not be used.
-         -->
-         <resumptionTokenExpiration>7200</resumptionTokenExpiration>
-	 <!-- How many sets/identifiers/records to send for the request before issuing a resumption token. A value less than 0 indicates that a complete list of records will be returned. -->
-         <resumeAfter>250</resumeAfter>
-         <!-- These field names will be used when there is no any mapping provided in the collectionConfig.xml and OAIConfig.xml -->
-         <DCmetadataNames>dc.Title,dc.Creator,dc.Subject,dc.Description,dc.Publisher,dc.Contributor,dc.Date,dc.Type,dc.Format,dc.Identifier,dc.Source,dc.Language,dc.Relation,dc.Coverage,dc.Rights</DCmetadataNames>
-         <!-- a list of metadata formats supported by this repository -->
-         <ListMetadataFormats>
-            <metadataFormat metadataPrefix="oai_dc">
-                <metadataPrefix>oai_dc</metadataPrefix>
-                <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
-                <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
-            <mappingList>
+  <!--<OAIStylesheet></OAIStylesheet> -->
+  
+  <!-- The time period in which a newly generated resumption token will remain valid, specified in second. Hence, the default
+  value 7200 is equivalent to 2 hours.        
+  If the resumeAfter parameter is less than 0, this value will not be used.
+  -->
+  <resumptionTokenExpiration>7200</resumptionTokenExpiration>
+  <!-- How many sets/identifiers/records to send for the request before issuing a resumption token. A value less than 0 (e.g. -1) indicates that a complete list of records will be returned. -->
+  <resumeAfter>250</resumeAfter>
+  <!-- These field names will be used when there is no any mapping provided in the collectionConfig.xml and OAIConfig.xml -->
+  <DCmetadataNames>dc.Title,dc.Creator,dc.Subject,dc.Description,dc.Publisher,dc.Contributor,dc.Date,dc.Type,dc.Format,dc.Identifier,dc.Source,dc.Language,dc.Relation,dc.Coverage,dc.Rights</DCmetadataNames>
+  <!-- a list of metadata formats supported by this repository -->
+  <ListMetadataFormats>
+    <metadataFormat metadataPrefix="oai_dc">
+      <metadataPrefix>oai_dc</metadataPrefix>
+      <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
+      <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
+      <mappingList>
         <!-- 
         This mapping will be used when there is no mapping provided in the collectionConfig.xml for the oai_dc metadata format.
@@ -52,10 +52,10 @@
         **Bear in mind: if this mapping list is not present, the standard dc. metadata names (15 in total) will be used to retrieve metadata in the database.
         -->
-            <mapping>dc.Title,dls.Title</mapping>
-            <mapping>dc.Subject,dls.Subject</mapping>  
-            <mapping>dc.Language,dls.Language</mapping>  
-            <mapping>dc.Organization,dls.Organization</mapping>  
-           </mappingList>
-        </metadataFormat>
-         </ListMetadataFormats>
+	<mapping>dc.Title,dls.Title</mapping>
+	<mapping>dc.Subject,dls.Subject</mapping>  
+	<mapping>dc.Language,dls.Language</mapping>  
+	<mapping>dc.Organization,dls.Organization</mapping>  
+      </mappingList>
+    </metadataFormat>
+  </ListMetadataFormats>
 </OAIConfig>