Index: other-projects/gs3-webservices-java-client/trunk/build.xml
===================================================================
--- other-projects/gs3-webservices-java-client/trunk/build.xml	(revision 21846)
+++ other-projects/gs3-webservices-java-client/trunk/build.xml	(revision 21848)
@@ -66,5 +66,5 @@
 	<echo>- ant clean</echo>
 	<echo>	for deleting the *.class files from the GS3democlient and GS3Fedora sources</echo>
-	<echo>- ant dist-clean</echo>
+	<echo>- ant distclean</echo>
 	<echo>	for deleting the *.class files from the sources, the QBRdata.jar, fedoraGS3.jar, executable jar file, and any zips of the project folder</echo>	
         <echo>- ant update</echo> 
@@ -92,7 +92,17 @@
 </target>
 
+<!--
+http://ananthkannan.blogspot.com/2009/12/java-exception-unknown-source.html
+"Sometimes when debugging application we may run into this exception - Java Exception unknown source.
+The possible reason could be when compiling the application, javac ant tasks omits debug option by defaut. So we will have to explicity set debug flag to true. See the javac ant task documentation for more info. You can mention some thing like below:
+
+<target name="compile">
+  <javac srcdir="${src.dir}" destdir="{dest.dir}." debug="on" debuglevel="lines,vars,source" />
+</target>"
+-->
+
 <!-- Compilation first ensures the existence of QBRdata.jar AND fedoraGS3.jar by checking whether these jars already exist and, if not, generating them. It is then that the actual compilation of the GS3democlient starts. By now the QBRdata classes of the GS3democlient src folder would have been compiled, but that does not matter as javac only compiles when class files are outdated or when they have not been generated yet.-->
 <target name="compile-demo-client" description="Compiles the GS3 demo-client" depends="ensure-QBRdata-jar,ensure-fedoraGS3-jar,ensure-gs3-for-client">
-    <javac srcdir="${democlient.rootdir}">
+    <javac srcdir="${democlient.rootdir}" debug="on" debuglevel="lines,vars,source">
       <classpath refid="project.classpath"/>
       <exclude name="${gs3services.rel.path}/**" /> <!--gs3services package needs official gsdl.jar to compile, so we skip it as it is not part of the client anyway-->
@@ -114,5 +124,5 @@
 </target>
 
-<target name="dist-clean" description="Removes the project-specific jars fedoraGS3.jar, QBRdata.jar, ${exec.jar.name} files AND all class files from the GS3DemoClient, GS3Fedora and GSearchInstaller source folders" depends="clean">
+<target name="distclean" description="Removes the project-specific jars fedoraGS3.jar, QBRdata.jar, ${exec.jar.name} files AND all class files from the GS3DemoClient, GS3Fedora and GSearchInstaller source folders" depends="clean">
    <delete includeEmptyDirs="true" failonerror="false">
     <fileset file="${basedir}/GSearchInstaller.jar"/>
@@ -164,5 +174,5 @@
     usetimestamp="true" />
   <!-- compile it up: specifying the file to be compiled explicitly (sourcepath="")--> 
-  <javac sourcepath="" srcdir="${basedir}" destdir="${basedir}" >
+  <javac sourcepath="" srcdir="${basedir}" destdir="${basedir}" debug="on" debuglevel="lines,vars,source">
     <include name="**/CheckJavaVersion.java"/>
   </javac>
@@ -178,5 +188,5 @@
   <get src="${gs3forclient.svn.path}/MyNodeList.java" dest="${basedir}/tmp/MyNodeList.java" />
   <!-- compile it up: specifying the file to be compiled explicitly --> 
-  <javac srcdir="${basedir}/tmp" destdir="${basedir}/tmp" >
+  <javac srcdir="${basedir}/tmp" destdir="${basedir}/tmp" debug="on" debuglevel="lines,vars,source">
     <classpath refid="project.classpath"/>
     <include name="**/*.java"/>
@@ -189,5 +199,5 @@
 <!-- Targets to generate the project-specific jar files QBRdata.jar and fedoraGS3.jar -->
 <target name="QBRdatajar" description="Compiles and creates the QBRdata.jar file needed by GS3demo-client">
-   <javac srcdir="${democlient.rootdir}/${QBRdata.rel.path}">
+   <javac srcdir="${democlient.rootdir}/${QBRdata.rel.path}" debug="on" debuglevel="lines,vars,source">
       <classpath refid="project.classpath"/>
    </javac>
@@ -199,5 +209,5 @@
 
 <target name="fedoraGS3jar" description="Compiles and creates the fedoraGS3.jar file needed by GS3demo-client">
-   <javac srcdir="${fedorags3.rootdir}">
+   <javac srcdir="${fedorags3.rootdir}" debug="on" debuglevel="lines,vars,source">
       <classpath refid="project.classpath"/>
    </javac>
@@ -208,5 +218,5 @@
 <!-- Target to generate the standalone (reusable) jar files DLservices.jar -->
 <target name="DLservicesjar" description="Compiles and creates the DLservices.jar standalone, reusable library file">
-   <javac srcdir="${democlient.rootdir}/${dlservices.rel.path}">
+   <javac srcdir="${democlient.rootdir}/${dlservices.rel.path}" debug="on" debuglevel="lines,vars,source">
       <classpath refid="project.classpath"/>
    </javac>
@@ -219,5 +229,5 @@
 <!-- Target that generates the GSearchInstaller jar file -->
 <target name="GSearchInstallerjar" description="Compiles and creates the jar file for the stand-alone GSearchInstaller application">
-   <javac srcdir="${gsearchinstaller.rootdir}"/>
+   <javac srcdir="${gsearchinstaller.rootdir}" debug="on" debuglevel="lines,vars,source" />
    <jar destfile="GSearchInstaller.jar"
      basedir="${gsearchinstaller.rootdir}/"